<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: The m17n Library Documentation</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li class="current"><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>The m17n Library Documentation </h1><h3 class="version">1.6.2 </h3><h2><a class="anchor" id="what">
What is the m17n library?</a></h2>
<p>The <em>m17n</em> <em>library</em> is a multilingual text processing library for the C language.</p>
<ul>
<li>
<p class="startli">It is a free and open source software.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">It is for any GNU/Linux and Unix applications/libraries.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">It realizes multilingualization of many aspects of applications/libraries.</p>
<p class="endli"></p>
</li>
</ul>
<p>The word "m17n" is an abbreviation of "multilingualization".</p>
<p>The m17n library provides following facilities to handle multilingual text.</p>
<ul>
<li>
<p class="startli"><em>M-text</em>: A data structure for a multilingual text. It is basically a string but with attributes called text property, and is designed to substitute for the C string. It is the most important object of the m17n library.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Functions for creating and processing M-texts.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Functions for converting M-texts from/to strings encoded in various existing formats.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">A huge character space, which contains all the Unicode characters and more non-Unicode characters.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli"><em>Chartable:</em> A data structure that contains per-character information efficiently.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Functions for inputting and displaying M-texts on a window system.</p>
<p class="endli"></p>
</li>
</ul>
<h2><a class="anchor" id="usage">
How to use it?</a></h2>
<p>Simply include &lt;m17n<em></em>.h&gt; in your program, and link it with the m17n library by -lm17n. See <a class="el" href="group__m17nIntro.html">Introduction</a> for the detail. </p>
<h2><a class="anchor" id="extralib">
External libraries and data</a></h2>
<p>The m17n library utilizes these external libraries. They are not mandatory but many functions of the m17n library depend on them.</p>
<ul>
<li>
<p class="startli">m17n-db -- <a href="http://www.m17n.org/m17n-lib-en/download/m17n-db-1.5.0.tar.gz">http://www.m17n.org/m17n-lib-en/download/m17n-db-1.5.0.tar.gz</a></p>
<p>Provide various information to the m17n library.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">libxml2 -- <a href="http://xmlsoft.org/">http://xmlsoft.org/</a></p>
<p>Used by the functions <a class="el" href="group__m17nTextProperty.html#ga4830a8a120aeed2185d6da8fd2daa05e" title="Serialize text properties in an M-text.">mtext_serialize()</a> and <a class="el" href="group__m17nTextProperty.html#ga82e022961a26f82ddf580782a50d94bf" title="Deserialize text properties in an M-text.">mtext_deserialize()</a>. Those functions return NULL when libxml2 is not available,</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">fribidi -- <a href="http://fribidi.sourceforge.net/">http://fribidi.sourceforge.net/</a></p>
<p>Used for BIDI processing. If it is not available, the rendering engine of the m17n library can't handle such script as Arabic and Hebrew correctly.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">freetype -- <a href="http://www.freetype.org/">http://www.freetype.org/</a></p>
<p>Used for handling local fonts.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">fontconfig -- <a href="http://www.fontconfig.org/">http://www.fontconfig.org/</a></p>
<p>Used for handling local fonts supported by the freetype library.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">fontconfig -- <a href="http://freedesktop.org/Software/fontconfig">http://freedesktop.org/Software/fontconfig</a></p>
<p>Used for finding local fonts in combination with Xft.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">xft -- <a href="http://freedesktop.org/Software/Xft">http://freedesktop.org/Software/Xft</a></p>
<p>Used for drawing text with local fonts by X Render Extension of X server in combination with fontconfig.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">GD</p>
<p>Used for rendering text with local fonts on bitmap/pixmap.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">libotf -- <a href="http://www.m17n.org/libotf/">http://www.m17n.org/libotf/</a></p>
<p>Used for handling OpenTypee fonts in combination with freetype and Xft.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">anthy -- <a href="http://anthy.sourceforge.jp/">http://anthy.sourceforge.jp/</a></p>
<p>Used for the Japanese input method ja-anthy.mim.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">wordcut -- <a href="http://thaiwordseg.sourceforge.net/">http://thaiwordseg.sourceforge.net/</a></p>
<p>Used for finding Thai word boundary in the example program example/linebreak.c.</p>
<p class="endli"></p>
</li>
</ul>
<h2><a class="anchor" id="contact">
Contact us:</a></h2>
<p>Global IT Security Group<br/>
 Information Technology Research Institute<br/>
 National Institute of Advanced Industrial Science and Technology</p>
<p>Web: <a href="http://www.m17n.org/m17n-lib-en/">http://www.m17n.org/m17n-lib-en/</a></p>
<p>Bug report: <a href="mailto:m17n-lib-bug-XXXX@m17n.org">m17n-lib-bug-XXXX@m17n.org</a> (Replace XXXX with current year in 4 digits.)</p>
<p>Mailing lists: <a href="http://www.m17n.org/m17n-lib-en/mailinglist.html">http://www.m17n.org/m17n-lib-en/mailinglist.html</a></p>
<h2><a class="anchor" id="ack">
Acknowledgements</a></h2>
<p>Special thanks to:</p>
<ul>
<li>
<p class="startli">Dimitri van Heesch &lt;<a href="mailto:dimitri@stack.nl">dimitri@stack.nl</a>&gt;</p>
<p>Author of Doxygen &lt;<a href="http://www.stack.nl/~dimitri/doxygen/">http://www.stack.nl/~dimitri/doxygen/</a>&gt;. Without this tool, it would have been impossible to create this documentation.</p>
<p class="endli"></p>
</li>
<li>
<p class="startli">Information-technology Promotion Agency (IPA), Japan</p>
<p>Writing this documentation was partially funded by Information-technology Promotion Agency (IPA) &lt;<a href="http://www.ipa.go.jp/about/english/index.html">http://www.ipa.go.jp/about/english/index.html</a>&gt; in fiscal year 2001.</p>
<p class="endli"></p>
</li>
</ul>
 
<hr>
Copyright (C) 2001 Information-technology Promotion Agency (IPA)<p>
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)<p>

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts, and no Back-Cover Texts.  A
copy of the license is included in the appendix entitled "GNU Free
Documentation License".

 </div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
